import * as i0 from '@angular/core';
import { Pipe, NgModule } from '@angular/core';

/**
 * This method is used to dynamically resolve a component instance from a given {@link ChangeDetectorRef}.
 * By binding a method using getExecutionContext, you can simply call any method in the context of the current component.
 */
function getExecutionContext(cdRef) {
    return cdRef['context'];
}

function _fnApplyHelper(thisArg, method, args) {
    return method.apply(thisArg, args === undefined ? [] : (Array.isArray(args) ? args : [args]));
}

class FnApplyPipe {
    changeDetectorRef;
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
    }
    transform(method, args, thisArg) {
        return _fnApplyHelper(thisArg ?? getExecutionContext(this.changeDetectorRef), method, args);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.9", ngImport: i0, type: FnApplyPipe, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Pipe });
    static ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "17.3.9", ngImport: i0, type: FnApplyPipe, isStandalone: true, name: "fnApply" });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.9", ngImport: i0, type: FnApplyPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'fnApply',
                    pure: true,
                    standalone: true
                }]
        }], ctorParameters: () => [{ type: i0.ChangeDetectorRef }] });

class FnMethodPipe {
    constructor() { }
    transform(context, method, args) {
        return _fnApplyHelper(context, context[method], args);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.9", ngImport: i0, type: FnMethodPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
    static ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "17.3.9", ngImport: i0, type: FnMethodPipe, isStandalone: true, name: "fnMethod" });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.9", ngImport: i0, type: FnMethodPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'fnMethod',
                    pure: true,
                    standalone: true
                }]
        }], ctorParameters: () => [] });

class FunctionExpressionModule {
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.9", ngImport: i0, type: FunctionExpressionModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.9", ngImport: i0, type: FunctionExpressionModule, imports: [FnApplyPipe,
            FnMethodPipe], exports: [FnApplyPipe, FnMethodPipe] });
    static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.9", ngImport: i0, type: FunctionExpressionModule });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.9", ngImport: i0, type: FunctionExpressionModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [],
                    imports: [
                        FnApplyPipe,
                        FnMethodPipe
                    ],
                    exports: [FnApplyPipe, FnMethodPipe]
                }]
        }] });

/*
 * Public API Surface of ngx-function-expression
 */

/**
 * Generated bundle index. Do not edit.
 */

export { FnApplyPipe, FnMethodPipe, FunctionExpressionModule };
//# sourceMappingURL=ngx-function-expression.mjs.map
